/**
 * Generated by Apache Royale Compiler from org\apache\royale\binding\ChainBinding.as
 * org.apache.royale.binding.ChainBinding
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.binding.ChainBinding');
goog.provide('org.apache.royale.binding.ChainBinding.ChainWatcher');

goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.events.ValueChangeEvent');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.core.IDocument');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 * @implements {org.apache.royale.core.IDocument}
 */
org.apache.royale.binding.ChainBinding = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.binding.ChainBinding', org.apache.royale.binding.ChainBinding);


/**
 * @private
 * @type {Array}
 */
org.apache.royale.binding.ChainBinding.prototype._source;


/**
 * @protected
 * @type {Object}
 */
org.apache.royale.binding.ChainBinding.prototype.document;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.binding.ChainBinding.prototype._destination;


/**
 * @export
 * @type {Object}
 */
org.apache.royale.binding.ChainBinding.prototype.watcherChain;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.binding.ChainBinding.prototype.value;


/**
 * @private
 */
org.apache.royale.binding.ChainBinding.prototype.applyBinding = function() {
  var /** @type {boolean} */ chainSet = this.evaluateSourceChain();
  if (chainSet)
    this.applyValue();
};


/**
 * @private
 * @return {boolean}
 */
org.apache.royale.binding.ChainBinding.prototype.evaluateSourceChain = function() {
  var self = this;
  function valueChangeHandler(event) {
    if (event.propertyName != propName)
      return;
    self.value = event.newValue;
    self.applyValue();
  };
  var /** @type {number} */ n = this.source.length;
  var /** @type {Object} */ obj = this.document;
  for (var /** @type {number} */ i = 0; i < n - 1; i++) {
    var /** @type {string} */ propName = org.apache.royale.utils.Language.string(this.source[i]);
    var /** @type {Object} */ propObj = obj[propName];
    var /** @type {org.apache.royale.binding.ChainBinding.ChainWatcher} */ watcher = new org.apache.royale.binding.ChainBinding.ChainWatcher(propName, org.apache.royale.utils.Language.closure(this.applyBinding, this, 'applyBinding'));
    obj.addEventListener("valueChange", org.apache.royale.utils.Language.closure(watcher.handler, watcher, 'handler'));
    if (propObj == null)
      return false;
    obj = propObj;
  }
  propName = org.apache.royale.utils.Language.string(this.source[n - 1]);
  obj.addEventListener("valueChange", valueChangeHandler);
  this.value = obj[propName];
  return true;
};


/**
 * @private
 */
org.apache.royale.binding.ChainBinding.prototype.applyValue = function() {
  var self = this;
  function handler(event) {
    if (event.propertyName != propName)
      return;
    if (event.oldValue != null)
      event.oldValue.removeEventListener("valueChange", handler);
    self.applyValue();
  };
  var /** @type {string} */ destinationName;
  if (org.apache.royale.utils.Language.is(this.destination, String)) {
    destinationName = org.apache.royale.utils.Language.as(this.destination, String);
    this.document[destinationName] = this.value;
    return;
  }
  var /** @type {number} */ n = Number(this.destination.length);
  var /** @type {Object} */ obj = this.document;
  for (var /** @type {number} */ i = 0; i < n - 1; i++) {
    var /** @type {string} */ propName = org.apache.royale.utils.Language.string(this.destination[i]);
    var /** @type {Object} */ propObj = obj[propName];
    if (propObj == null) {
      obj.addEventListener("valueChange", handler);
      return;
    }
    obj = propObj;
  }
  obj[this.destination[n - 1]] = this.value;
};


/**
 *  @copy org.apache.royale.core.IDocument#setDocument()
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @export
 * @param {Object} document
 * @param {string=} id
 */
org.apache.royale.binding.ChainBinding.prototype.setDocument = function(document, id) {
  id = typeof id !== 'undefined' ? id : null;
  this.document = document;
};


org.apache.royale.binding.ChainBinding.prototype.get__source = function() {
  return this._source;
};


org.apache.royale.binding.ChainBinding.prototype.set__source = function(value) {
  this._source = value;
};


org.apache.royale.binding.ChainBinding.prototype.get__destination = function() {
  return this._destination;
};


org.apache.royale.binding.ChainBinding.prototype.set__destination = function(value) {
  this._destination = value;
};


org.apache.royale.binding.ChainBinding.prototype.set__strand = function(value) {
  this.applyBinding();
};


Object.defineProperties(org.apache.royale.binding.ChainBinding.prototype, /** @lends {org.apache.royale.binding.ChainBinding.prototype} */ {
/**
  * @export
  * @type {Array} */
source: {
get: org.apache.royale.binding.ChainBinding.prototype.get__source,
set: org.apache.royale.binding.ChainBinding.prototype.set__source},
/**
  * @export
  * @type {Object} */
destination: {
get: org.apache.royale.binding.ChainBinding.prototype.get__destination,
set: org.apache.royale.binding.ChainBinding.prototype.set__destination},
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.binding.ChainBinding.prototype.set__strand}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.binding.ChainBinding.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ChainBinding', qName: 'org.apache.royale.binding.ChainBinding', kind: 'class' }], interfaces: [org.apache.royale.core.IBead, org.apache.royale.core.IDocument] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.binding.ChainBinding.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'watcherChain': { type: 'Object'}
      };
    },
    accessors: function () {
      return {
        'source': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.binding.ChainBinding'},
        'destination': { type: 'Object', access: 'readwrite', declaredBy: 'org.apache.royale.binding.ChainBinding'},
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.binding.ChainBinding'}
      };
    },
    methods: function () {
      return {
        'ChainBinding': { type: '', declaredBy: 'org.apache.royale.binding.ChainBinding'},
        'setDocument': { type: 'void', declaredBy: 'org.apache.royale.binding.ChainBinding', parameters: function () { return [  { index: 1, type: 'Object', optional: false },{ index: 2, type: 'String', optional: true } ]; }}
      };
    }
  };
};



/**
 * @constructor
 * @param {string} propertyName
 * @param {Function} callback
 */
org.apache.royale.binding.ChainBinding.ChainWatcher = function(propertyName, callback) {
  this.propertyName = propertyName;
  this.callback = callback;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.binding.ChainBinding.ChainWatcher', org.apache.royale.binding.ChainBinding.ChainWatcher);


/**
 * @private
 * @type {string}
 */
org.apache.royale.binding.ChainBinding.ChainWatcher.prototype.propertyName;


/**
 * @private
 * @type {Function}
 */
org.apache.royale.binding.ChainBinding.ChainWatcher.prototype.callback;


/**
 * @export
 * @param {org.apache.royale.events.ValueChangeEvent} event
 */
org.apache.royale.binding.ChainBinding.ChainWatcher.prototype.handler = function(event) {
  if (event.propertyName != this.propertyName)
    return;
  if (event.oldValue != null)
    event.oldValue.removeEventListener("valueChange", org.apache.royale.utils.Language.closure(this.handler, this, 'handler'));
  this.callback();
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.binding.ChainBinding.ChainWatcher.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ChainWatcher', qName: 'org.apache.royale.binding.ChainBinding.ChainWatcher', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.binding.ChainBinding.ChainWatcher.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'ChainWatcher': { type: '', declaredBy: 'org.apache.royale.binding.ChainBinding.ChainWatcher', parameters: function () { return [  { index: 1, type: 'String', optional: false },{ index: 2, type: 'Function', optional: false } ]; }},
        'handler': { type: 'void', declaredBy: 'org.apache.royale.binding.ChainBinding.ChainWatcher', parameters: function () { return [  { index: 1, type: 'org.apache.royale.events.ValueChangeEvent', optional: false } ]; }}
      };
    }
  };
};